package com.example.ueberwachungssystem;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.camera.core.ExperimentalGetImage;
import androidx.camera.view.PreviewView;

import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.ToggleButton;

import com.example.ueberwachungssystem.Detection.DetectionReport;
import com.example.ueberwachungssystem.Detection.Detector;
import com.example.ueberwachungssystem.Detection.VideoDetector;
import com.example.ueberwachungssystem.logger.Logger;
import com.jjoe64.graphview.GraphView;

@ExperimentalGetImage
public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);


        ImageView inputImageView = findViewById(R.id.inputImageView);
        ImageView outputImageView = findViewById(R.id.outputImageView);
        PreviewView previewView = findViewById(R.id.previewView);


        // Mic stuff
        TextView textView= (TextView) findViewById(R.id.textView); //Set textview for showing logged content
        Logger logger = new Logger(this.getClass().getSimpleName(), textView, "");
        GraphView graph = (GraphView) findViewById(R.id.graph);
        MicrophoneDetector mic = new MicrophoneDetector(this, logger, graph);
        mic.startDetection();



        AudioRecorder audioRecorder = new AudioRecorder(this);

        // video Stuff
        VideoDetector vd = new VideoDetector(this);
        //vd.setPreviewView(previewView);
        vd.debugProcessing(inputImageView, outputImageView);
        vd.setOnDetectionListener(new Detector.OnDetectionListener() {
            @Override
            public void onDetection(@NonNull DetectionReport detectionReport) {
                Log.d("onDetection", detectionReport.toString());
            }
        });
        vd.startDetection();


        ToggleButton toggleButton = findViewById(R.id.toggleButton);
        toggleButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (toggleButton.isChecked())
                {
                    //vd.startDetection();
                    vd.startRecording();
                    audioRecorder.startRecording();

                }
                else {
                    //vd.stopDetection();
                    vd.stopRecording();
                    audioRecorder.stopRecording();
                }
            }
        });
    }
}